# ICFS -- Interactively Controlled File System.

## Motivation 

Traditional access control mechanisms in operating systems allow the same level of access to all processes running on behalf of the same user. This typically enables malicious processes to read and/or modify all data accessible to the user running a vulnerable application. It can be dealt using various mandatory access control mechanisms, but these are often complicated to configure and are rarely used in common user oriented scenarios. This thesis focuses on design and implementation of a filesystem layer which delegates the decision to allow or deny access to a filesystem object by a specific process to the user.

## Goals
* analyse the problem and design a solution
* implement the solution using the FUSE framework
* test the solution and demonstrate its benefits